算法:JavaScript两数之和

题目

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

代码
/**
 * @param {number[]} nums
 * @param {number} target
 * @return {number[]}
 */
 //[2, 7, 11, 15]  9
 //把差存进数组,如果当前遍历数组有和差相等的值则把当前值的小标和差的下标输出来
 var twoSum = function(nums, target)  {
    let theSet = []
    for(let i = 0; i < nums.length; i++){
       if( theSet.indexOf( nums[i] )  !== -1){   //当前数和数组匹对是否存在
         return [theSet.indexOf( nums[i] ), i];     //如果有则返回当前值再数组中的位置和当前下标
       }else{
        theSet.push(target - nums[i] );//如果数组没有当前值则相减把差存进去数组  9-2=7 i=1 -- 9-7=2 i=2 -- 9-11=-2 i=3 -- 9-15=-6 i=4
       }
    }
   return [0,0];
};
 /*
var twoSum = function(nums, target) {
    var arr = [];
    var num = [];

    /*
    for(var i = 0;i<nums.length;i++){
        for(var j = i+1; i< nums.length; j++){
            if(nums[i] ==  target - nums[j] ){
            arr = [i,j];
            return arr;
            }
        }

    }
    ***
};

var twoSum = function(nums, target) {
    const diffs = new Map();
    const j = nums.findIndex((a, i) => diffs.has(target - a) || diffs.set(a, i) && 0);
    return [diffs.get(target - nums[j]), j];
};
*/

  

时间: 2024-10-23 14:27:08

算法:JavaScript两数之和的相关文章

LeetCode算法题——两数之和(python)

两数之和: 给定一个整数数组和一个目标值,找出数组中和为目标值的两个数.你可以假设每个输入只对应一种答案,且同样的元素不能被重复利用.例如:给定 nums = [2, 7, 11, 15], target = 9.由nums[0] + nums[1] = 2 + 7 = 9,所以返回 [0, 1] 原文地址:http://blog.51cto.com/13921683/2318829

LeetCode算法1—— 两数之和

给定一个整数数组和一个目标值,找出数组中和为目标值的两个数. 你可以假设每个输入只对应一种答案,且同样的元素不能被重复利用. 示例: 给定 nums = [2, 7, 11, 15], target = 9 因为 nums[0] + nums[1] = 2 + 7 = 9 所以返回 [0, 1] Solution: class Solution { public int[] twoSum(int[] nums, int target) { int[] arr = new int[2]; for(

每日一道算法题--两数之和

题目描述: 给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标. 你可以假设每种输入只会对应一个答案.但是,你不能重复利用这个数组中同样的元素. 示例: 给定 nums = [2, 7, 11, 15], target = 9 因为 nums[0] + nums[1] = 2 + 7 = 9所以返回 [0, 1] 代码: function(nums, target) { let arr = [] for (let i = 0

算法(两数之和)

func twoSum(nums []int, target int) []int { array1 := make([]int, 0) final := 0 for i := 0; i < len(nums); i++ { for j := 0; j < len(nums); j ++ { if (nums[i] + nums[j] == target && i != j) { array1 = append(array1, i) array1 = append(array1

力扣算法初级——两数之和

相关知识点: 1.c++计算数组的大小:使用“数组名+size()” 2.c++返回多个数据的方法:return {a,b,……} 3.哈希表:散列表(Hash table,也叫哈希表),是根据关键码值(Key value)而直接进行访问的数据结构.也就是说,它通过把关键码值映射到表中一个位置来访问记录,以加快查找的速度.这个映射函数叫做散列函数,存放记录的数组叫做散列表. 原文地址:https://www.cnblogs.com/181118ljh123/p/11650082.html

前端与算法 leetcode 1. 两数之和

目录 # 前端与算法 leetcode 1. 两数之和 题目描述 概要 提示 解析 解法一:暴力法 解法二:HashMap法 算法 传入[2,7,11,1,12,34,4,15],19的运行结果 执行结果 GitHub仓库 # 前端与算法 leetcode 1. 两数之和 题目描述 给定一个整数数组 nums?和一个目标值 target,请你在该数组中找出和为目标值的那?两个?整数,并返回他们的数组下标. 你可以假设每种输入只会对应一个答案.但是,你不能重复利用这个数组中同样的元素. 示例: 给

算法练习:两数之和

题目:给定一个整型数组,是否能找出两个数使其和为指定的某个值?注:整型数组中不存在相同的数. 一.解题方法 1.暴力破解法(时间复杂度O(n^2) ) 这是最容易想到的一种方法,即使用两层循环,从数组里取出一个数,然后在此数之后部分找出另外一个数,计算两数之和,判断是否等于指定值.如下: //直观的办法,使用两个循环 bool IsExistSumOfTwoNum( int nArray[], int nCount, int nSum ) { bool bRet = false; for ( i

[算法] LeetCode 1.两数之和

LeetCode 1.两数之和(python) 1.朴素解法 最朴素的两个for循环大法: class Solution: def twoSum(self, nums: List[int], target: int) -> List[int]: for i in range(len(nums)): for j in range(i+1,len(nums)): if nums[i] + nums[j] == target: return [i, j] 但注意,不要用enumerate函数写,会超时

【Leetcode】【简单】【1. 两数之和】【JavaScript】

题目描述 1. 两数之和 给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标. 你可以假设每种输入只会对应一个答案.但是,你不能重复利用这个数组中同样的元素. 示例: 给定 nums = [2, 7, 11, 15], target = 9 因为 nums[0] + nums[1] = 2 + 7 = 9所以返回 [0, 1] 来源:力扣(LeetCode)链接:https://leetcode-cn.com/problem